package sk.kasv.szaszak.file.School;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import java.util.Scanner;

public class SchoolApp {

    private Scanner sc;
    public static final String FILENAME="students.txt";

    private List <Student> list=new ArrayList<>();

    public boolean openFile(){
        try {
            sc =new Scanner(new File(FILENAME));
        } catch (FileNotFoundException e) {
            System.out.println("Error! Can't open file.");
            return false;
        }
        return true;
    }
public void readData(){
      while (sc.hasNextLine()) {
          String Line = sc.nextLine();
          Student student = parsData(Line);
          list.add(student);
      }
}
public void start(){
        boolean res=openFile();
        if (res)
            readData();
    System.out.println("Number of students: "+list.size());
    //avgAge();
    //avgNotPresent();
    //bestStudent();
    //printBestStudent(bestStudent());
    //printWorstStudent(worstStudent());
    //success();
    //search();
    sortByLname();
    print();
}

    private void print() {
        for(Student s:list)
            System.out.println(s.getFname()+" "+s.getLname());
    }

    private double bestStudent() {
        double bestAvg=5;

        for(int i=0;i< list.size();i++){
            Student temp=list.get(i);
            if(temp.getAvgMark()<bestAvg)
                bestAvg=temp.getAvgMark();
        }
        return bestAvg;
    }

    private double worstStudent() {
        double worstAvg = 1;

        for (int i = 0; i < list.size(); i++) {
            Student temp = list.get(i);
            if (temp.getAvgMark() > worstAvg)
                worstAvg = temp.getAvgMark();
        }
        return worstAvg;
    }
    public void printBestStudent(double bestAvg){
        System.out.println("The best avarage is: "+bestAvg);
        System.out.println("List of best students: ");
        for(Student temp: list){
            if(temp.getAvgMark()==bestAvg)
                System.out.println(" -"+temp.getFname()+" "+temp.getLname());
        }
    }
    public void printWorstStudent(double worstAvg){
        System.out.println("The worst avarage is: "+worstAvg);
        System.out.println("List of worst students: ");
        for(Student temp: list){
            if(temp.getAvgMark()==worstAvg)
                System.out.println(" -"+temp.getFname()+" "+temp.getLname());
        }
    }
    private double avgNotPresent() {
        double sum=0;
        for(int i = 0; i< list.size(); i++) {
            sum+= list.get(i).getNotPresent();
        }
        double avgNotPresent = sum/ list.size();
        double  oneDecimal= Math.round(avgNotPresent*10) / 10.0;
        System.out.println("Avarage notPresent: "+oneDecimal);
        return avgNotPresent;
    }

    private double avgAge() {
        double sum=0;
        for(int i = 0; i< list.size(); i++) {
           sum+= list.get(i).getAge();
        }
        double avgAge = sum/ list.size();
        double  oneDecimal= Math.round(avgAge*10) / 10.0;
        System.out.println("Avarage age: "+oneDecimal);
        return avgAge;
    }

    public Student parsData(String Line){
        String[] arr=Line.split(" ");
        String fname=arr[0];
        String lname=arr[1];
        int age=Integer.parseInt(arr[2]);
    int notPresent=Integer.parseInt(arr[3]);
    int pro=Integer.parseInt(arr[4]);
    int web=Integer.parseInt(arr[5]);
    int dbs=Integer.parseInt(arr[6]);
    int ekn=Integer.parseInt(arr[7]);
    int log=Integer.parseInt(arr[8]);
    Student newStudent=new Student(fname,lname,age,notPresent,pro,web,dbs,ekn,log);
    return newStudent;
}
public void success(){
        for(int i=0;i< list.size();i++){
            double avg=list.get(i).getAvgMark();
            String success;
String name=" "+list.get(i).getFname()+" "+list.get(i).getLname();
if(avg<=1.5)success="PV";
        else if(avg<=2.0)success="PVD";
        else if(avg<=4)success="prospel";
        else success="neprospel";
            System.out.println(name+" has "+success);
}
        }
        public void printByName(){
            System.out.println("Search: ");
            int result=0;
            Scanner scan= new Scanner(System.in);
                String search = scan.next().toUpperCase();
                for (Student temp : list) {
                    if (temp.getFname().toUpperCase().contains(search)||temp.getLname().toUpperCase().contains(search)) {
                        System.out.println(temp.getFname() + " " + temp.getLname());
                        result=1;
                    }
                }
                if(result==0) System.out.println("No results");
        }
            public void search(){
        Scanner scan=new Scanner(System.in);
        while(true){
            String input=scan.nextLine();
            switch(input){
                case "search": printByName();
                default:
            }
        }
            }
            public Student randomStudent(){
                Random rand= new Random();
                return list.get(rand.nextInt(0, list.size()));
            }
            public void sortByAvg(){
        list.sort((s1,s2)->s1.getAvgMark()>s2.getAvgMark()?1:-1);
            }
            public void sortByAge(){
        list.sort((s1,s2)->s1.getAge()>s2.getAge()?1:-1);
            }
            public void sortByNotPresent(){
        list.sort((s1,s2)->s1.getNotPresent()>s2.getNotPresent()?1:-1);
            }
            public void sortByLname(){
        list.sort((s1,s2)->s1.getLname().compareToIgnoreCase(s2.getLname()));
            }
        }


