package sk.kasv.szaszak.file.html;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

public class Multiply {

    private File myFile = null;
    private FileWriter fw;

    public static void main(String[] args) {
        Multiply table = new Multiply();
        boolean ret = table.createFile("index.html");
        if (ret==false){
            System.out.println("Error! Cannot create new file. App will terminate.");
            System.exit(1);
        }
        ret = table.openFileW();
        if (ret==false) {
            System.out.println("Error! Cannot create new file. App will terminate.");
            System.exit(2);
        }
        table.writeBetIntoFile(table.generateTableArr());
        table.closeFile();

    }

    public int[][] generateTableArr() {
        int[][] arr = new int[21][21];
        for (int i = 0; i < arr.length; i++) {
            for (int y = 0; y < arr.length; y++)
                arr[i][y] = i * y;
        }
        arr[0] = arr[1];
        for (int i = 1; i < arr.length; i++)
            arr[i][0] = arr[i][1];
        arr[0][0] = 0;
        return arr;
    }

    public void writeBetIntoFile(int[][] arr) {
        try {
            fw.write("<table>");
            fw.write("<tr>");
            for (int y = 0; y < 21; y++)
                fw.write("<th>" + arr[0][y] + "</th>");
            fw.write("</tr>");
            for (int i = 0; i < 21; i++) {
                fw.write("<tr><th>" + arr[i][0] + "</th>");
                for (int j = 0; j < 21; j++)
                    fw.write("<td>" + arr[i][j] + "</td>");
                fw.write("</tr>");
            }
            fw.write("</table>");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }

    }

    public boolean createFile(String filename) {
        myFile = new File(filename);
        if (myFile == null)
            return false;
        else return true;
    }
    public boolean openFileW() {
        try {
            fw = new FileWriter(myFile);
        } catch (IOException e) {
            return false;
        }
        return true;
    }
    public boolean closeFile() {
        try {
            fw.close();
        } catch (IOException e) {
            return false;
        }
        return true;
    }
}

